Index: trunk/source/processes/hadronic/models/parton_string/History
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/History	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/History	(revision 962)
@@ -14,4 +14,25 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+23 June 2008 V. Uzhinsky (hadr-prtn-V09-01-02)
+   G4QGSMFragmentation.cc and G4LundStringFragmentation.cc were
+   decoupled at calculation of formation time due to adding methods
+   and member in G4VLongitudinalStringDecay class for manipulation
+   with string tension.
+
+   Memory leak was erased in G4QGSMFragmentation.cc and 
+   G4VLongitudinalStringDecay.cc thank to Gunter.
+
+18 June 2008 V. Uzhinsky (hadr-prtn-V09-01-01)
+   Changes in G4ExcitedString class were tagged. They are needed for
+   operation of FTF.
+
+13 June 2008 V. Uzhinsky    (hadr-prtn-V09-01-00)
+----------------------------------------------- 
+1. String fragmentation was revised, and parameters were tuned.
+2. FTF parameters were tuned for proton-proton interaction
+3. FTF parameters for pion-nucleon interactions were determined very rouhgly
+4. Quiasi-elastic hadron-nucleus scattering was implemented in FTF
+5. Formation time was implemented in FTF, and string tension was tuned
+
 
 25 May 2007 G.Folger       (hadr-prtn-V08-02-02)
@@ -53,2 +74,11 @@
 
 - D. Wright created History file for parton_string directory
+
+31 March 2008 V. Uzhinsky (hadr-string-diff-V09-01-00)
+--------------------------------------------------------
+
+- Elastic hadron intra-nuclear nucleon scattering was inserted in
+  FTF model. This allows to simulate quasi-elastic and multi-particles
+  production together.
+- Small re-orangement of FTF model was done. G4FTFCrossSection modules
+  were re-named into G4FTFParameters and moved to /diffraction
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/History
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/History	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/History	(revision 962)
@@ -1,3 +1,3 @@
-$Id: History,v 1.1 2007/04/24 10:32:59 gunter Exp $
+$Id: History,v 1.5 2008/12/09 10:43:47 vuzhinsk Exp $
 -------------------------------------------------------------------
 
@@ -15,7 +15,31 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+9 December 08, V. Uzhinsky (hadr-string-diff-V09-01-04)
+- Improvement of delete operators in FTF
+
+5 December 08, V. Uzhinsky (hadr-string-diff-V09-01-03)
+- Some objects did not erase in FTFModel desructor. These lead to memory 
+  leak.
 
 
+2 June 08, G.Folger 		(hadr-string-diff-V09-01-02)
+-  on branch geant4-09-01-patches_branch, fix compilation warning for unused 
+     variables in G4FTFModel.cc
+     
+
+
+??????????????????????????????      (hadr-string-diff-V09-01-01)
+
+31 March 2008 V. Uzhinsky           Tag : hadr-string-diff-V09-01-00
+- G4FTFParameters.cc and G4FTFParameters.hh were copied from G4FTFCrossSection
+  corresponding files.
+- New files - G4ElasticHNScattering have been added. They implement elastic 
+  scattering of hadron in intra-nuclear collisions in FTF model.
+- The corresponding changes have been done in G4FTFModel.cc and 
+  G4FTFParticipants.cc
+
+  
 24 Apr 2007 Gunter Folger  (hadr-string-diff-V08-02-00)
 -  merge in change done by ftf development.
 - Created History file.
+
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveExcitation.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveExcitation.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveExcitation.hh	(revision 962)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4DiffractiveExcitation.hh,v 1.1 2007/05/25 06:56:53 vuzhinsk Exp $
+// $Id: G4DiffractiveExcitation.hh,v 1.2 2008/04/25 14:20:13 vuzhinsk Exp $
 
 #ifndef G4DiffractiveExcitation_h
@@ -42,4 +42,5 @@
 class G4VSplitableHadron;
 class G4ExcitedString;
+#include "G4FTFParameters.hh"                            // Uzhi 19.04.08
 #include "G4ThreeVector.hh"
 
@@ -52,11 +53,9 @@
       virtual ~G4DiffractiveExcitation();
 
-      virtual G4bool ExciteParticipants (G4VSplitableHadron *aPartner, G4VSplitableHadron * bPartner) const;
+      virtual G4bool ExciteParticipants (G4VSplitableHadron *aPartner, 
+                                         G4VSplitableHadron * bPartner,
+                                         G4FTFParameters *theParameters) const;
+
       virtual G4ExcitedString * String(G4VSplitableHadron * aHadron, G4bool isProjectile) const;
-      
-//      void SetPtWidth(G4double aValue) { widthOfPtSquare = aValue*aValue; }
-//      void SetExtraMass(G4double aValue) { minExtraMass = aValue; }
-//      void SetMinimumMass(G4double aValue) { minmass = aValue; }
-
 
   private:
@@ -64,9 +63,6 @@
       G4DiffractiveExcitation(const G4DiffractiveExcitation &right);
       
-//    G4double ChooseX(G4double Xmin, G4double Xmax) const;                       // Uzhi
+      G4ThreeVector GaussianPt(G4double  AveragePt2, G4double maxPtSquare) const; // Uzhi
       G4double ChooseP(G4double Pmin, G4double Pmax) const;                       // Uzhi
-
-//    G4ThreeVector GaussianPt(G4double widthSquare, G4double maxPtSquare) const;
-      G4ThreeVector GaussianPt(G4double  AveragePt2, G4double maxPtSquare) const;  // Uzhi
       
       const G4DiffractiveExcitation & operator=(const G4DiffractiveExcitation &right);
@@ -74,11 +70,4 @@
       int operator!=(const G4DiffractiveExcitation &right) const;
 
-  private:
-// Model Parameters:
-/*                                                                                // Uzhi
-	const G4double widthOfPtSquare;	// width^2 of pt for string excitation    
-	const G4double minExtraMass;	// minimum excitation mass                
-	const G4double minmass;	// mean pion transverse mass; used for Xmin       
-*/                                                                                // Uzhi
 };
 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveHHScatterer.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveHHScatterer.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveHHScatterer.hh	(revision 962)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4DiffractiveHHScatterer.hh,v 1.3 2006/06/29 20:54:25 gunter Exp $
+// $Id: G4DiffractiveHHScatterer.hh,v 1.4 2008/04/25 14:20:13 vuzhinsk Exp $
 
 #ifndef G4DiffractiveHHScatterer_h
@@ -44,4 +44,5 @@
 class G4KineticTrack;
 #include "G4KineticTrackVector.hh"
+#include "G4FTFParameters.hh"                            // Uzhi 21.04.08
 
 class G4DiffractiveHHScatterer
@@ -57,4 +58,5 @@
 const G4DiffractiveExcitation * theExcitation;
 G4LundStringFragmentation * theStringFragmentation;
+G4FTFParameters  *theParameters;                       // Uzhi  21.04.08
 };
 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveSplitableHadron.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveSplitableHadron.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveSplitableHadron.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DiffractiveSplitableHadron.hh,v 1.4 2006/06/29 20:54:27 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFModel.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFModel.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFModel.hh	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4FTFModel.hh,v 1.5 2007/04/24 10:32:59 gunter Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: G4FTFModel.hh,v 1.7 2008/04/25 14:20:13 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // Class Description
@@ -52,9 +52,11 @@
 class G4VSplitableHadron;
 class G4ExcitedString;
+
+#include "G4FTFParameters.hh"                            // Uzhi 29.03.08
 #include "G4FTFParticipants.hh"
 
 #include "G4ExcitedStringVector.hh"
 #include "G4DiffractiveExcitation.hh"
-
+#include "G4ElasticHNScattering.hh"
 
 class G4FTFModel : public G4VPartonStringModel
@@ -84,14 +86,16 @@
   
   private:     
-       
+
+       G4ReactionProduct theProjectile;       
        G4FTFParticipants theParticipants;
-       G4ReactionProduct theProjectile;
-       
+
+       G4FTFParameters  *theParameters;        // Uzhi  29.03.08
        G4DiffractiveExcitation * theExcitation;
-
+       G4ElasticHNScattering   * theElastic;   // Uzhi 29.03.08
 
 
 };
 
+// ------------------------------------------------------------
 inline 
 G4V3DNucleus * G4FTFModel::GetWoundedNucleus() const
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParticipants.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParticipants.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParticipants.hh	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4FTFParticipants.hh,v 1.4 2006/06/29 20:54:32 gunter Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: G4FTFParticipants.hh,v 1.5 2008/03/31 15:34:01 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 
@@ -41,4 +41,5 @@
 
 #include "G4VParticipants.hh"
+#include "G4FTFParameters.hh"   // Uzhi 29.03.08
 #include <vector>
 #include "G4Nucleon.hh"
@@ -60,13 +61,15 @@
       int operator!=(const G4FTFParticipants &right) const;
 
-      void BuildInteractions(const G4ReactionProduct  &thePrimary);
+      void GetList(const G4ReactionProduct  &thePrimary, 
+                         G4FTFParameters    *theParameters); // Uzhi 29.03.08
+
+      void StartLoop();
       G4bool Next();
       const G4InteractionContent & GetInteraction() const;
-
-      void StartLoop();
       
+      std::vector<G4InteractionContent *> theInteractions;
   private:
 
-      std::vector<G4InteractionContent *> theInteractions;
+//      std::vector<G4InteractionContent *> theInteractions;
   
       G4int currentInteraction;
@@ -95,4 +98,2 @@
 
 #endif
-
-
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveExcitation.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveExcitation.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveExcitation.cc	(revision 962)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4DiffractiveExcitation.cc,v 1.1 2007/05/25 06:56:53 vuzhinsk Exp $
+// $Id: G4DiffractiveExcitation.cc,v 1.7 2008/12/18 13:01:58 gunter Exp $
 // ------------------------------------------------------------
 //      GEANT 4 class implemetation file
@@ -31,12 +31,14 @@
 //      ---------------- G4DiffractiveExcitation --------------
 //             by Gunter Folger, October 1998.
-//         diffractive Excitation used by strings models
-//	   Take a projectile and a target
-//	   excite the projectile and target
+//        diffractive Excitation used by strings models
+//             Take a projectile and a target
+//             excite the projectile and target
 //  Essential changed by V. Uzhinsky in November - December 2006
 //  in order to put it in a correspondence with original FRITIOF
 //  model. Variant of FRITIOF with nucleon de-excitation is implemented.
 //  Other changes by V.Uzhinsky in May 2007 were introduced to fit
-//  meson-nucleon interactions  
+//  meson-nucleon interactions. Additional changes by V. Uzhinsky
+//  were introduced in December 2006. They treat diffraction dissociation
+//  processes more exactly.
 // ---------------------------------------------------------------------
 
